<template>
    <v-row justify="center">
      <v-btn class="back-button" color="primary" @click="handleBack" small outlined dark >
        <v-icon left>mdi-arrow-left-thick</v-icon>
        Retour
      </v-btn>
        <v-col cols="12" sm="8">
            <v-card class="elevation-3">
                <Loading :visible="isLoading" />
                <v-card-title>
                    Informations magasin
                </v-card-title>
                <v-list-item>
                    <v-list-item-content>
                        <v-form>
                            <v-list-item>
                                <v-text-field id="street" v-model="storeInfos.street" label="Adresse"
                                    :error-messages="streetErrors" class="input-field" dense>
                                </v-text-field>
                            </v-list-item>
                            <v-list-item>
                                <v-row>
                                    <v-col cols="8">
                                        <v-text-field id="city" v-model="storeInfos.city" label="Ville"
                                            :error-messages="cityErrors" class="input-field" dense>
                                        </v-text-field>
                                    </v-col>
                                    <v-col cols="4">
                                        <v-text-field id="zc" v-model="storeInfos.zc" label="Code postal"
                                            :error-messages="zcErrors" class="input-field" dense>
                                        </v-text-field>
                                    </v-col>
                                </v-row>
                            </v-list-item>
                            <v-list-item>
                                <v-text-field id="country" v-model="storeInfos.country" label="Pays"
                                    :error-messages="countryErrors" class="input-field" dense>
                                </v-text-field>
                            </v-list-item>
                            <v-card-actions>
                                <v-btn color="secondary" light small type="submit" @click="saveInfos">
                                    Sauvegarder
                                </v-btn>
                                <v-spacer></v-spacer>
                                <v-btn v-if="formMode==='edit'" color="error" light small type="submit" @click="handleDelete">
                                    <v-icon>mdi-delete</v-icon> Supprimer
                                </v-btn>
                            </v-card-actions>
                        </v-form>
                    </v-list-item-content>
                </v-list-item>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
import { mapFields } from 'vuex-map-fields';
import { mapActions, mapGetters } from 'vuex';
import {
  validationMixin
} from 'vuelidate';
import {
  required
} from 'vuelidate/lib/validators';
import NotificationMixin from '../../../mixins/NotificationMixin';
import Loading from '../../../components/Loading';
// import LoginForm from '../../components/login/LoginForm';
const servicePrefix = 'User';

export default {
  name: 'AdminStoreForm',
  mixins: [NotificationMixin, validationMixin],
  servicePrefix,
  components: {
    // LoginForm,
    Loading
  },
  validations: {
    storeInfos: {    
      street: {
        required
      },
      city: {
        required
      },
      country: {
        required
      },
      zc: {
        required
      }
    }
  },
  data() {
    return {
       storeInfos: {
        street: '',
        city: '',
        country: '',
        zc: '',
      },
      formMode: 'edit'
      }
  },
  computed: {
    streetErrors() {
      const errors = [];
      if (!this.$v.storeInfos.street.$dirty) return errors
      !this.$v.storeInfos.street.required && errors.push('Adresse requise')
      return errors
    },
    cityErrors() {
      const errors = [];
      if (!this.$v.storeInfos.city.$dirty) return errors
      !this.$v.storeInfos.city.required && errors.push('Ville requise')
      return errors
    },
    countryErrors() {
      const errors = [];
      if (!this.$v.storeInfos.country.$dirty) return errors
      !this.$v.storeInfos.country.required && errors.push('Pays requis')
      return errors
    },
    zcErrors() {
      const errors = [];
      if (!this.$v.storeInfos.zc.$dirty) return errors
      !this.$v.storeInfos.zc.required && errors.push('Code postal requis')
      return errors
    },
    ...mapFields('admin', ['stores', 'storesFound', 'company', 'storeCreated','isLoading']),
    ...mapGetters('admin', ['getStoreById'])

  },
  created() {
    if (!this.$route.params.id) {
      this.formMode = 'new';
    } else if (this.storesFound) {
      let res = this.getStoreById(this.$route.params.id);
      if (res) {
        this.storeInfos = {...res};
      } else {
        this.$router.push({name:'adminStores'});
      }
    }
    this.resetStoresChanged();
  },
  methods: {
    editProfile() {
      event.preventDefault();
      this.editMode = true;
    },
    saveInfos() {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      if (this.formMode === 'new') {
        this.storeInfos['company'] = `/companies/${this.company.id}`;
        this.createStore(this.storeInfos);
      } else if (this.formMode === 'edit') {
        this.updateStore(this.storeInfos);
      }
      
    },
    handleDelete(event) {
      event.preventDefault();
      this.deleteStore(this.$route.params.id);
    },
    handleBack() {
      this.$router.push({name:'adminStores'})
    },
    ...mapActions('admin', ['createCompany', 'createStore', 'updateStore', 'deleteStore','resetStoresChanged'])
  },
  watch: {
    storesFound(newStoresFound) {
      if (newStoresFound && this.$route.params.id) {
        let res = this.getStoreById(this.$route.params.id);
        if (res) {
          this.storeInfos = {...res};
        } else {
          this.$router.push({name:'adminStores'});
        }
      }
    }
  },
};
</script>

<style>
  .back-button {
    position: absolute;
    left: 10px;
    top: 0;
  }
</style>
